/* interface to autogenerated snippets.c file */
/* cairo_snippets (c) Øyvind Kolås 2004, released to the public domain */

#ifndef SNIPPETS_H
#define SNIPPETS_H

#include <cairo.h>

/* header files available for snippet usage */

#include "png_io.h"
#include <svg-cairo.h>
#include <math.h>

/* number of available snippets */
extern int snippet_count;

/* the basename of the snippets */
extern const char *snippet_name[];

/* the source for each of the snippets */
extern const char *snippet_source[];

/* run a snippet */
void
snippet_do (cairo_t *cr, int snippet_no);

/* utility function mapping a snippet name to a snippet number */
int
snippet_name2no (const char *name);

void
snippet_set_bg_png (cairo_t *cr, const char *file);

void
snippet_set_bg_svg (cairo_t *cr, const char *file);

#endif /* SNIPPETS_H */
